// Fig. 13.7: fig13_07.cpp
// Demonstrating auto_ptr
#include <iostream>
#include <memory>

using namespace std;

class Integer {
public:
   Integer( int i = 0 ) : value( i ) 
      { cout << "Constructor for Integer " << value << endl; } 
   ~Integer()  
      { cout << "Destructor for Integer " << value << endl; } 
   void setInteger( int i ) { value = i; }
   int getInteger() const { return value; }
private:
   int value;
};

int main()
{
   cout << "Creating an auto_ptr object that points "
        << "to an Integer\n";

   auto_ptr< Integer > ptrToInteger( new Integer( 7 ) );

   cout << "Using the auto_ptr to manipulate the Integer\n";
   ptrToInteger->setInteger( 99 );  
   cout << "Integer after setInteger: " 
        << ( *ptrToInteger ).getInteger()
        << "\nTerminating program" << endl;

   return 0;
}